PQueuedThreadPool< Work_T > Class Template Reference

High Level (queued work item) thread pool. More...

`#include <threadpool.h>`

Inheritance diagram for PQueuedThreadPool< Work_T >:

## Classes

class | QueuedWorkerThread

## Public Member Functions

| PQueuedThreadPool (unsigned maxWorkers=10, unsigned maxWorkUnits=0)
virtual PThreadPoolBase::WorkerThreadBase * | CreateWorkerThread ()
Public Member Functions inherited from PThreadPool< Work_T >
| PThreadPool (unsigned maxWorkers=10, unsigned maxWorkUnits=0)
bool | AddWork (Work_T *work, const char *group=NULL)
bool | RemoveWork (Work_T *work, bool removeFromWorker=true)
Public Member Functions inherited from PThreadPoolBase
| ~PThreadPoolBase ()
virtual WorkerThreadBase * | AllocateWorker ()
virtual WorkerThreadBase * | NewWorker ()
unsigned | GetMaxWorkers () const
void | SetMaxWorkers (unsigned count)
unsigned | GetMaxUnits () const
void | SetMaxUnits (unsigned count)
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual Comparison | Compare (const PObject &obj) const
| Compare the two objects and return their relative rank. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Additional Inherited Members

Public Types inherited from PThreadPool< Work_T >
typedef std::map< Work_T *, InternalWork > | ExternalToInternalWorkMap_T
typedef std::map< std::string, GroupInfo > | GroupInfoMap_t
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Public Attributes inherited from PThreadPool< Work_T >
ExternalToInternalWorkMap_T | m_externalToInternalWorkMap
GroupInfoMap_t | m_groupInfoMap
Protected Types inherited from PThreadPoolBase
typedef std::vector< WorkerThreadBase * > | WorkerList_t
Protected Member Functions inherited from PThreadPoolBase
| PThreadPoolBase (unsigned maxWorkerCount=10, unsigned maxWorkUnitCount=0)
virtual bool | CheckWorker (WorkerThreadBase *worker)
void | StopWorker (WorkerThreadBase *worker)
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...
Protected Attributes inherited from PThreadPoolBase
PMutex | m_listMutex
WorkerList_t | m_workers
unsigned | m_maxWorkerCount
unsigned | m_maxWorkUnitCount

## Detailed Description

### template<class Work_T>
class PQueuedThreadPool< Work_T >

High Level (queued work item) thread pool.

## Constructor & Destructor Documentation

template<class Work_T >

PQueuedThreadPool< Work_T >::PQueuedThreadPool | ( | unsigned | maxWorkers = `10`,
|  | unsigned | maxWorkUnits = `0`
| ) |  |

inline

## Member Function Documentation

template<class Work_T >

virtual PThreadPoolBase::WorkerThreadBase* PQueuedThreadPool< Work_T >::CreateWorkerThread | ( |  | ) |

inline virtual

Implements PThreadPoolBase.

The documentation for this class was generated from the following file:

- threadpool.h